<?php
namespace HCM\FPA\Repository;

use Doctrine\DBAL\Connection;
use Doctrine\ORM\EntityManager;
use Folha\Entities\VabBeneficiario;
use Folha\Entities\FpaVincevento;
use HCM\Util\Messages;

class ValorReferenciaRepository {

    protected  $connection;
    public function __construct(Connection $connection, EntityManager $entityManager) {
        $this->connection = $connection;
        $this->entityManager = $entityManager;
    }

    public function getReferenciaPorDescricao($referencia, $nrorg, $dtmescompetenc, $descricao){
        $params = array(
            "P_REFERENCIA"     => $referencia,
            "P_NRORG"          => $nrorg,
            "P_DTMESCOMPETENC" => $dtmescompetenc,
            "P_DSREFERENCIA"   => $descricao);

        $sql = "select * from FPA_VALORREFERENCIAM
                  JOIN FPA_VALORREFERENCIAH
                    ON FPA_VALORREFERENCIAH.NRVALORREFERENCIAM = FPA_VALORREFERENCIAM.NRVALORREFERENCIAM
                   AND FPA_VALORREFERENCIAH.VRREFERENCIA = :P_REFERENCIA
                   AND FPA_VALORREFERENCIAH.DTMESCOMPETENC =
                                                         (SELECT MAX(DTMESCOMPETENC)
                                                            FROM FPA_VALORREFERENCIAH
                                                           WHERE FPA_VALORREFERENCIAH.NRVALORREFERENCIAM       = FPA_VALORREFERENCIAM.NRVALORREFERENCIAM
                                                             AND FPA_VALORREFERENCIAH.DTMESCOMPETENC <= TO_DATE(:P_DTMESCOMPETENC, 'DD/MM/YYYY'))

                WHERE FPA_VALORREFERENCIAM.NRORG = :P_NRORG
                AND FPA_VALORREFERENCIAM.DSREFERENCIA = :P_DSREFERENCIA";

        $retorno = \Setforms2\Shared\Registry::getEntityManager()->getConnection()->fetchAll($sql, $params);
        return $retorno;
    }

    public function getReferenciaPorNrValorReferencia($nrorg, $dtmescompetenc, $nrValorReferencia) { 
        
        $query = <<<SQL
SELECT 
    * 
FROM 
    FPA_VALORREFERENCIAM VRM
JOIN 
    FPA_VALORREFERENCIAH VRH
        ON(
            VRM.NRVALORREFERENCIAM = VRH.NRVALORREFERENCIAM
            AND VRH.DTMESCOMPETENC =
                                    (SELECT 
                                        MAX(DTMESCOMPETENC)
                                     FROM 
                                        FPA_VALORREFERENCIAH
                                     WHERE 
                                        FPA_VALORREFERENCIAH.NRVALORREFERENCIAM = VRH.NRVALORREFERENCIAM
                                        AND FPA_VALORREFERENCIAH.DTMESCOMPETENC <= TO_DATE(:DTMESCOMPETENC, 'DD/MM/YYYY')
                                    )
        )
WHERE 
    VRM.NRORG = :NRORG 
    AND VRM.NRVALORREFERENCIAM = :NRVALORREFERENCIAM
SQL;

        $retorno = $this->connection->fetchAssoc($query, array( "DTMESCOMPETENC"     => $dtmescompetenc,
                                                                "NRORG"              => $nrorg,
                                                                "NRVALORREFERENCIAM" => $nrValorReferencia,
                                                              ) 
                                           );
        return $retorno;
    }

} 
