<?php
namespace HCM\Geral\Controllers;

use HCM\Geral\Services\ImportacaoXmlEsocialService;
use HCM\Util\HCMParameters;
use HCM\Util\Messages;
use HCM\Util\MsgProcesso;
use Zeedhi\Framework\Controller\Crud;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DataSource\Manager;
use Zeedhi\Framework\DataSource\ParameterBag;
use Zeedhi\Framework\DataSource\FilterCriteria;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response\Notification;
use HCM\Util\FPA;
use HCM\Util\HCM;

class ImportacaoXmlEsocialController {
    
    public function __construct (Manager $dataSourceManager, ParameterBag $parameterBag, HCMParameters $hcmParameters, ImportacaoXmlEsocialService $importacaoXmlEsocialService){
        $this->parameterBag = $parameterBag;
        $this->hcmParameters = $hcmParameters;
        $this->importacaoXmlEsocialService = $importacaoXmlEsocialService;

        // parent::__construct($dataSourceManager);
    }
    
    public function importarXml(DTO\Request\DataSet $request, DTO\Response $response){
        try {
            $row = $request->getDataSet()->getRows()[0];
            
            $retornos = $this->importacaoXmlEsocialService->importarXml($row);
            $status = false;
            $dataset = array();
            
            foreach ($retornos as $nmarquivo => $retorno) {
                if($retorno['status'] == true){
                    $status = true;
                    foreach($retorno['messages'] as $message){
                        $dataset[] = array(
                            'NMARQUIVO' => $nmarquivo,
                            'IDTIPOMSG' => 'S',
                            'DSMENSAGEM' => $message
                        );
                    }
                    
                    // if(array_key_exists('NRESTRUTURAM', $retorno)){
                    //     $dataset[] = array(
                    //         'NMARQUIVO' => $nmarquivo,
                    //         'IDTIPOMSG' => 'S',
                    //         'DSMENSAGEM' => 'Dados importados corretamente! Número da estrutura: '.$retorno['NRESTRUTURAM'].''
                    //     );
                    // }else if(array_key_exists('NROCUPACAOM', $retorno)){
                    //     $dataset[] = array(
                    //         'NMARQUIVO' => $nmarquivo,
                    //         'IDTIPOMSG' => 'S',
                    //         'DSMENSAGEM' => 'Dados importados corretamente! Número da ocupação: '.$retorno['NROCUPACAOM'].''
                    //     );
                    // }else if(array_key_exists('NRVINCULOM', $retorno)){
                    //     $dataset[] = array(
                    //         'NMARQUIVO' => $nmarquivo,
                    //         'IDTIPOMSG' => 'S',
                    //         'DSMENSAGEM' => 'Dados importados corretamente! Número do vínculo: '.$retorno['NRVINCULOM'].''
                    //     );
                    // }else if(array_key_exists('NRHORDIAM', $retorno)){
                    //     $dataset[] = array(
                    //         'NMARQUIVO' => $nmarquivo,
                    //         'IDTIPOMSG' => 'S',
                    //         'DSMENSAGEM' => 'Dados importados corretamente! Número do horário: '.$retorno['NRHORDIAM'].''
                    //     );
                    // }
                }else{
                    $dataset[] = array(
                        'NMARQUIVO' => $nmarquivo,
                        'IDTIPOMSG' => 'E',
                        'DSMENSAGEM' => $retorno['message']
                    );
                }
            }
            
            if ($status === true) {
                $response->addMessage(new DTO\Response\Message('Importação finalizada', Notification::TYPE_SUCCESS));
            } else {
                $response->addMessage(new DTO\Response\Message('Importação finalizada com erros', Notification::TYPE_ERROR));
            }
            $response->addDataSet(new \Zeedhi\Framework\DataSource\DataSet('importarXml', $dataset));
        } catch (\Exception $e) {
            if ($e->getCode() != 0) {
                $response->addMessage(new DTO\Response\Message($e->getMessage(), DTO\Response\Message::TYPE_ERROR));
            } else {
                $response->setError(new \Zeedhi\Framework\DTO\Response\Error($e->getMessage(), $e->getCode()));
            }
        }
    }
    
    protected function processConditionValue($condition) {
        return $condition['value'];
    }
    protected function populateParameterBag(FilterCriteria $filterCriteria) {

        $conditions = array();
        foreach ($filterCriteria->getConditions() as $condition) {
            $columnName = $condition['columnName'];
            if (in_array($columnName, $this->parameterBagColumns)) {
                $this->parameterBag->set($columnName, $this->processConditionValue($condition));
            } else {
                $conditions[] = $condition;
            }
        }
        $newFilterCriteria = new FilterCriteria(
            $filterCriteria->getDataSourceName(),
            $conditions,
            $filterCriteria->getPage(),
            $filterCriteria->getPageSize()
        );


        return $newFilterCriteria;
    }
}